/*
 * Created on 11 juin 2005
 *
 */
package istia.st.m2vc.appli;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import istia.st.m2vc.core.*;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import istia.st.m2vc.core.IControleur;
import javax.swing.UIManager;
import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;

/**
 * @author serge
 *
 */
public class Main {

  public static void main(String[] args) throws Exception {
    // variables locales
    IControleur monControleur = null;
    // message de patience
    System.out.println("Application en cours d'initialisation. Patientez...");
    try {
      // on instancie le contrleur de l'application
      monControleur = (IControleur) (new XmlBeanFactory(new ClassPathResource(
          "m2vc.xml"))).getBean("controleur");
    }
    catch (Exception ex) {
      // on s'arrte
      abort("Erreur lors de l'initialisation du contrleur M2VC-win", ex, 1);
    }
    // excution application
    System.out.println("Application lance...");
    try {
      monControleur.run();
    }
    catch (Exception ex) {
      // on affiche l'erreur et on s'arrte
      abort("Erreur d'excution", ex, 2);
    }
    // fin normale
    System.out.println("Application termine...");
    System.exit(0);
  }

  // fin anormale
  private static void abort(String message, Exception ex, int exitCode) throws
      Exception {
    // on affiche l'erreur
    System.out.println(message);
    System.out.println("---------------------------------------");
    System.out.println(ex.toString());
    System.out.println("---------------------------------------");
    // on laisse l'utilisateur voir le message
    System.out.println("Tapez [enter] pour terminer l'application...");
    BufferedReader IN = new BufferedReader(new InputStreamReader(System.in));
    IN.readLine();
    // on s'arrte
    System.exit(exitCode);
  }
}
