package istia.st.m2vc.appli;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import istia.st.m2vc.core.BaseVueJFrame;

public class VueSaisir
    extends BaseVueAppli {
  JPanel contentPane;
  JLabel jLabel1 = new JLabel();
  JTextField jTextFieldSaisie = new JTextField();
  JButton jButtonMemoriser = new JButton();
  JButton jButtonConsulter = new JButton();
  JButton Quitter = new JButton();
  JLabel jLabelEtat = new JLabel();

  //Construire le cadre
  public VueSaisir() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Initialiser le composant
  private void jbInit() throws Exception {
    contentPane = (JPanel)this.getContentPane();
    jLabel1.setText("Tapez un texte :");
    jLabel1.setBounds(new Rectangle(28, 32, 144, 27));
    contentPane.setLayout(null);
    this.setSize(new Dimension(400, 256));
    this.setTitle("VueSaisir");
    jTextFieldSaisie.setSelectionStart(11);
    jTextFieldSaisie.setText("");
    jTextFieldSaisie.setBounds(new Rectangle(28, 79, 287, 28));
    jButtonMemoriser.setBounds(new Rectangle(24, 138, 101, 26));
    jButtonMemoriser.setToolTipText("");
    jButtonMemoriser.setText("Mmoriser");
    jButtonMemoriser.addActionListener(new
                                       VueSaisir_jButtonMemoriser_actionAdapter(this));
    jButtonConsulter.setText("Consulter");
    jButtonConsulter.addActionListener(new VueSaisir_jButtonConsulter_actionAdapter(this));
    jButtonConsulter.setBounds(new Rectangle(142, 138, 101, 26));
    jButtonConsulter.setToolTipText("");
    jButtonConsulter.setActionCommand("jButton1");
    Quitter.setText("Quitter");
    Quitter.addActionListener(new VueSaisir_Quitter_actionAdapter(this));
    Quitter.setBounds(new Rectangle(259, 138, 101, 26));
    Quitter.setToolTipText("");
    jLabelEtat.setText("Consultation en cours. Veuillez patienter...");
    jLabelEtat.setBounds(new Rectangle(29, 196, 343, 30));
    contentPane.add(jLabel1, null);
    contentPane.add(jTextFieldSaisie, null);
    contentPane.add(jButtonMemoriser, null);
    contentPane.add(jButtonConsulter, null);
    contentPane.add(Quitter, null);
    contentPane.add(jLabelEtat, null);
  }

  //Redfini, ainsi nous pouvons sortir quand la fentre est ferme
  protected void processWindowEvent(WindowEvent e) {
  }

  void jButtonMemoriser_actionPerformed(ActionEvent e) {
    // on rcupre le texte saisi
    String texte = jTextFieldSaisie.getText().trim();
    // on refuse les textes vides
    if ("".equals(texte)) {
      // message d'erreur et retour  la saisie
      JOptionPane.showMessageDialog(this, "Vous n'avez pas saisi de texte",
                                    "Erreur", JOptionPane.INFORMATION_MESSAGE);
      return;
    }
    // on mmorise le texte dans la session
    getSession().getTextes().add(texte);
    // on nettoie
    jTextFieldSaisie.setText("");
  }

  void jButtonConsulter_actionPerformed(ActionEvent e) {
  // on affiche le label d'tat
  jLabelEtat.setVisible(true);
  // on passe la main  la classe parent
  super.excuteAction("consulter");
  }

  void Quitter_actionPerformed(ActionEvent e) {
  // on passe la main  la classe parent
  super.excute("quitter");
  }

  // affiche
  public void affiche(){
    // on cache le label d'tat
    jLabelEtat.setVisible(false);
    // affiche classe parent
    super.affiche();
  }
}

class VueSaisir_jButtonMemoriser_actionAdapter
    implements java.awt.event.ActionListener {
  VueSaisir adaptee;

  VueSaisir_jButtonMemoriser_actionAdapter(VueSaisir adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonMemoriser_actionPerformed(e);
  }
}

class VueSaisir_jButtonConsulter_actionAdapter implements java.awt.event.ActionListener {
  VueSaisir adaptee;

  VueSaisir_jButtonConsulter_actionAdapter(VueSaisir adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonConsulter_actionPerformed(e);
  }
}

class VueSaisir_Quitter_actionAdapter implements java.awt.event.ActionListener {
  VueSaisir adaptee;

  VueSaisir_Quitter_actionAdapter(VueSaisir adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.Quitter_actionPerformed(e);
  }
}
