package istia.st.m2vc.core;

/**
 * @author serge.tahe@univ-angers.fr, juin 2005
 *
 */

public class Barriere {

  // tat overt - ferm de la barrire
  private boolean ouverte;

  /**
   * @return Returns the ouverte.
   */
  public boolean isOuverte() {
    return ouverte;
  }

  /**
   * @param ouverte The ouverte to set.
   */
  public void setOuverte(boolean ouverte) {
    this.ouverte = ouverte;
  }

  // fermeture barrire
  public synchronized void reset() {
    ouverte = false;
  }

  // ouverture barrire
  public synchronized void set() {
    if (! ouverte){
      ouverte = true;
      this.notify();
    }
  }

  // attente barrire
  public synchronized void waitOne() {
    if (!ouverte) {
      try {
        this.wait();
      }
      catch (InterruptedException ex) {
        throw new RuntimeException(ex.toString());
      }
    }
  }
}
