package istia.st.m2vc.core;

import javax.swing.JFrame;

/**
 * @author serge.tahe@univ-angers.fr, juin 2005
 *
 */
public class BaseVueJFrame
    extends JFrame implements IVue, Runnable {

  // champs privs
  private String nom; // nom de la vue
  private String action; // nom de l'action que le contrleur doit excuter
  private Barriere synchro; // objet de synchronisation controleur - vues
  private Thread threadVue; // objet de synchronisation de la vue


  /**
   * @return Returns the action.
   */
  public String getAction() {
    return action;
  }

  /**
   * @param action
   *          The action to set.
   */
  public void setAction(String action) {
    this.action = action;
  }

  /**
   * @return Returns the nom.
   */
  public String getNom() {
    return nom;
  }

  /**
   * @param nom
   *          The nom to set.
   */
  public void setNom(String nom) {
    this.nom = nom;
  }


  /**
   * @return Returns the synchro.
   */
  public Barriere getSynchro() {
    return synchro;
  }
  /**
   * @param synchro The synchro to set.
   */
  public void setSynchro(Barriere synchro) {
    this.synchro = synchro;
  }

  // affiche la vue
  public void affiche() {
    // on s'affiche dans le thread d'affichage
    if (threadVue == null) {
      // on cre le thread d'affichage
      threadVue = new Thread(this);
      threadVue.start();
    } else {
      // on s'affiche
      this.setVisible(true);
    }
  }

  // cache la vue
  public void cache() {
    // on se cache
    this.setVisible(false);
  }

  // action asynchrone
  public void excute(String action) {
    // on note l'action  excuter
    this.setAction(action);
    // on passe la main au contrleur
    synchro.set();
  }

  // mthode du thread d'affichage
  public void run() {
    // affichage de la vue
    this.setVisible(true);
  }
}
